package functions;

import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.Toolkit;
import java.io.*;
import ui.MainWindow;
import ui.addlinks.AddLinks;
import javax.swing.JTextArea;
import java.util.regex.Pattern;
import java.util.regex.Matcher;

public class ClipboardMonitor implements Runnable{
private MainWindow mParent;
private String mClipboardContains;

public ClipboardMonitor(MainWindow parent){
    
    mParent=parent;
     mClipboardContains= getClipboardContents();
}

public void Dodaj(String str){

    if(mParent.dodajIsOpen()>0){
    //System.out.println(str);
    str=mParent.getDodaj().getTextArea().getText()+str;
    //System.out.println(str);
    mParent.getDodaj().setVisible(false);
    mParent.getDodaj().dispose();
      AddLinks links = new AddLinks(mParent,str);
      links.setVisible(true);
      mParent.setDodaj(links);mParent.setDodajIsOpen(mParent.dodajIsOpen()+1);
    }
    else{
      AddLinks links = new AddLinks(mParent,str);
      links.setVisible(true);
      mParent.setDodaj(links);
      mParent.setDodajIsOpen(mParent.dodajIsOpen()+1);
}

  }

public void run(){
  while(true){
    String s = getClipboardContents();
    if(!s.equals(mClipboardContains)){
      mClipboardContains=s;
      String str=new String("");
      Pattern p = Pattern.compile("http://[^\\s\"<;#'>]*");
      Matcher matcher = p.matcher(s);
      while (matcher.find()) {
	str+="\n"+matcher.group();
	}
      if(str.length()>0)Dodaj(str);
    }
    try{
      Thread.sleep(1000);
    } catch ( InterruptedException e) {  } 
  }
}
// from: http://www.javapractices.com/topic/TopicAction.do?Id=82 on BSD License
public String getClipboardContents() {
    String result = "";
    Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
    //odd: the Object param of getContents is not currently used
    Transferable contents = clipboard.getContents(null);
    boolean hasTransferableText =
      (contents != null) &&
      contents.isDataFlavorSupported(DataFlavor.stringFlavor)
    ;
    if ( hasTransferableText ) {
      try {
        result = (String)contents.getTransferData(DataFlavor.stringFlavor);
      }
      catch (UnsupportedFlavorException ex){
        //highly unlikely since we are using a standard DataFlavor
        System.out.println(ex);
        ex.printStackTrace();
      }
      catch (IOException ex) {
        System.out.println(ex);
        ex.printStackTrace();
      }
    }
    return result;
  }


} 
