package ui.history;

import java.util.Vector;
import javax.swing.*;
import functions.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;
import ui.MainWindow;
import engine.*;

public class History extends JFrame implements ActionListener{
  Vector<Vector> data;
  JTable mTable;
  MainWindow mParent;
  public History(MainWindow parent){
    super("JGetRap :: History");
    mParent=parent;
    setSize(650,400);
    JButton clear = new JButton("ClearHistory",new ImageIcon("graphics/ok.png"));
    JButton close = new JButton("Close",new ImageIcon("graphics/no.png"));
    clear.setActionCommand("clear");
    clear.addActionListener(this);
    close.setActionCommand("close");
    close.addActionListener(this);
    Vector<String> titles = new Vector<String>();
    titles.add("");
    titles.add("Nazwa");
    titles.add("Położenie");
    titles.add("Rozmiar");
 
    data = new Vector<Vector>();
    Vector<Vector<String>> linki = Task.getTableRows();
    for(Vector<String> tmp:linki){
    Vector<String> row = new Vector<String>();
    if("Oczekuje".equals(tmp.get(3))){
    row.add(new String(tmp.get(0)));
    row.add(new String(tmp.get(1)));
    row.add(new String(tmp.get(5)));
    row.add(new String(tmp.get(6)));
    data.add(row);
    }

}
    mTable = new JTable(new DefaultTableModel(data, titles){
      @Override
      public boolean isCellEditable(int row, int column) {return false;}
    });

    mTable.setColumnSelectionAllowed(false);
    mTable.setCellSelectionEnabled(false);
    mTable.setRowSelectionAllowed(true);
    mTable.setShowGrid(false);
    mTable.setShowHorizontalLines(true) ;
    TableColumn col = mTable.getColumnModel().getColumn(0);
    col.setMaxWidth(16); 
    col.setMinWidth(16);
    mTable.getColumnModel().getColumn(0).setCellRenderer(new ImageRenderer(""));
    JScrollPane scrollPane = new JScrollPane(mTable);
    this.setLayout(new GridBagLayout());
    GridBagConstraints c = new GridBagConstraints();
    c.fill = GridBagConstraints.HORIZONTAL;
    c.anchor = GridBagConstraints.PAGE_START;
    c.fill = GridBagConstraints.BOTH;
    c.gridx = 0;
    c.gridy = 0;
    c.weightx = 1.0;
    c.weighty = 1.0;
    c.gridwidth = 2;
    add(scrollPane,c);
    c.insets = new Insets(10,10,10,10);  //top padding
    c.ipady = 10;
    c.ipadx = 20;
    c.anchor = GridBagConstraints.PAGE_END;
    c.gridx = 0;
    c.gridy = 1;
    c.weighty = 0.0;
    c.gridwidth = 1;
    add(clear,c);
    c.insets = new Insets(10,10,10,10);  //top padding
    c.gridx = 1;
    c.gridy = 1;
    c.weighty = 0.0;
    add(close,c);
  }

 public void actionPerformed(ActionEvent e) {
    if ("clear".equals(e.getActionCommand())) {
      for(int i=0 ;i<data.size();i++) {
      Vector<Vector<String>> linki = Task.getTableRows();
      for(int j=0;j<linki.size();j++){
	if(linki.get(j).get(1).equals(data.get(i).get(1))){linki.remove(j);}
      }
    mParent.getTable().updateUI();
}
      data.clear();
      mTable.repaint() ;
    } else if("close".equals(e.getActionCommand())){
      setVisible(false);
           dispose();

    }
}
} 
 
